//
//  ViewController.m
//  ExplicitAnimationExample
//
//  Created by Tommy MacWilliam on 4/16/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "QuartzCore/CAAnimation.h"
#import "ViewController.h"

@implementation ViewController

@synthesize button1 = _button1;
@synthesize button2 = _button2;

- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

- (IBAction)buttonPressed:(id)sender
{
    // top button
    if ([sender tag] == 0) {
        // create path to animate along
        CGMutablePathRef path = CGPathCreateMutable();
        
        // start path at button center
        CGPathMoveToPoint(path, NULL, self.button1.center.x, self.button1.center.y);
        // move button to top left corner
        CGPathAddLineToPoint(path, NULL, 50.0f, 50.0f);
        CGPathAddLineToPoint(path, NULL, 50.0f, 200.0f);
        CGPathAddLineToPoint(path, NULL, 200.0f, 100.0f);
        
        // create animation from path we just created
        CAKeyframeAnimation *translateAnimation = [CAKeyframeAnimation animationWithKeyPath:@"position"];
        translateAnimation.path = path;
        translateAnimation.duration = 3.0f;
        
        // animate button along path
        [self.button1.layer addAnimation:translateAnimation forKey:@"position"];
    }
    
    // bottom button
    else if ([sender tag] == 1) {
        // create three different transformation matrices
        NSValue *first = [NSValue valueWithCATransform3D:CATransform3DMakeRotation(0.0, 1.0f, 1.0f, 0.0f)];
        NSValue *second = [NSValue valueWithCATransform3D:CATransform3DMakeRotation(M_PI, 1.0f, 1.0f, 0.0f)];
        NSValue *third = [NSValue valueWithCATransform3D:CATransform3DMakeScale(2.0, 2.0, 2.0)];
        
        // create animation from transformation values
        CAKeyframeAnimation *rotateAnimation = [CAKeyframeAnimation animationWithKeyPath:@"transform"];
        rotateAnimation.values = [NSArray arrayWithObjects:first, second, third, nil];
        rotateAnimation.duration = 2.0f;
        rotateAnimation.autoreverses = YES;
        
        // animate button
        [self.button2.layer addAnimation:rotateAnimation forKey:@"transform"];
    }
}

@end
