//
//  ViewController.m
//  ImageViewExample
//
//  Created by Tommy MacWilliam on 4/15/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "ViewController.h"

@implementation ViewController

@synthesize imageView = _imageView;
@synthesize picker = _picker;

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // initialize image picker
    self.picker = [[UIImagePickerController alloc] init];
    self.picker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
    self.picker.allowsEditing = YES;
    self.picker.delegate = self;
}

- (void)viewDidUnload
{
    [super viewDidUnload];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

/**
 * Fired when button is pressed
 *
 */
- (IBAction)pressed
{
    // show image picker
    [self presentModalViewController:self.picker animated:YES];
}

/**
 * Fired when user selects image from picker
 *
 */
- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info 
{  
    // display selected image in UIImageView and get rid of picker
    self.imageView.image = [info objectForKey:UIImagePickerControllerEditedImage]; 
    [self dismissModalViewControllerAnimated:YES];
}

@end
