//
//  ShadowView.m
//  ShadowsExample
//
//  Created by Tommy MacWilliam on 4/15/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "ShadowView.h"

@implementation ShadowView

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    return self;
}

- (void)drawRect:(CGRect)rect
{
    // get context to draw to
    CGContextRef context = UIGraphicsGetCurrentContext();
    // push state onto stack
    CGContextSaveGState(context);
    
    // create path for triangle
    CGMutablePathRef path1 = CGPathCreateMutable();
    // start at top
    CGPathMoveToPoint(path1, NULL, 50.0f, 50.0f);
    // move to bottom left
    CGPathAddLineToPoint(path1, NULL, 10.0f, 90.0f);
    // move to bottom right
    CGPathAddLineToPoint(path1, NULL, 90.0f, 90.0f);
    CGPathCloseSubpath(path1);
    
    // add shadow to triangle
    CGContextSetShadow(context, CGSizeMake(10.0f, 10.0f), 5.0f);
    
    // draw triangle path
    CGContextAddPath(context, path1);
    CGContextSetFillColorWithColor(context, [UIColor greenColor].CGColor);
    CGContextFillPath(context);
    
    // restore state (to before we added a shadow)
    CGContextRestoreGState(context);
    
    // create another path for a second triangle
    CGMutablePathRef path2 = CGPathCreateMutable();
    // start at top
    CGPathMoveToPoint(path2, NULL, 250.0f, 250.0f);
    // move to bottom left
    CGPathAddLineToPoint(path2, NULL, 210.0f, 290.0f);
    // move to bottom right
    CGPathAddLineToPoint(path2, NULL, 290.0f, 290.0f);
    CGPathCloseSubpath(path2);
    
    // draw second triangle path (without shadow)
    CGContextAddPath(context, path2);
    CGContextSetFillColorWithColor(context, [UIColor yellowColor].CGColor);
    CGContextFillPath(context);
}

@end
